package com.sa.ibiz.demo.demoapp.controller.demo;

import java.io.InputStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.sql.Timestamp;
import javax.annotation.Resource;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.Data;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.node.ObjectNode;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import com.sa.ibiz.demo.ibizutil.domain.ActionResult;
import com.sa.ibiz.demo.demo.service.DataEntityService;
import com.sa.ibiz.demo.ibizutil.domain.AutoCompleteItem;
import com.sa.ibiz.demo.demo.domain.DataEntity;
import com.sa.ibiz.demo.demo.service.dto.DataEntitySearchFilter;
import com.sa.ibiz.demo.demoapp.controller.demo.vo.*;
import org.springframework.cglib.beans.BeanGenerator;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.util.StringUtils;
import java.io.IOException;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.validation.annotation.Validated;
import org.springframework.http.ResponseEntity;
import org.springframework.beans.factory.annotation.Autowired;
import com.sa.ibiz.demo.ibizutil.domain.RedirectResult;
import javax.validation.constraints.NotBlank;
import com.sa.ibiz.demo.ibizutil.domain.AutoCompleteItem;
import java.math.BigInteger;
import com.alibaba.fastjson.JSONObject;

@RestController
@RequestMapping("/demoapp/demo/dataentity")
public class DataEntityController{



    @Autowired
	private DataEntityService dataentityService;
	/**
	 * 获取服务对象
	*/
	protected DataEntityService getService(){
		return this.dataentityService;
	}
	/**
	 * 实体界面行为
	 * @param param 参数集合
	 * @return
	 */
	@PostMapping(value="uiaction/initall")
	public ResponseEntity<JSONObject>uiactionInitall(@RequestBody Map param) {
		String strkey="";
		JSONObject obj =new JSONObject();
		DataEntity entity=new DataEntity();
		String srfkeys=param.get("srfkeys").toString();
		String srfkeyArr[] =srfkeys.split(";");
		for(String srfkey : srfkeyArr){
			if(!StringUtils.isEmpty(srfkey)){
				entity.setDeid(srfkey);
				this.getService().get(entity);
			}
			this.getService().initAll(entity);
		}
		obj.put("success",true);
		obj.put("info","初始化实体相关配置完成！");
		obj.put("reloadData",false);
		return ResponseEntity.ok().body(obj);
	}



	@PostMapping(value="maineditform/update")
	public ResponseEntity<DataEntity_EditForm_Main> mainEditFormUpdate(@Validated @RequestBody DataEntity_EditForm_Main form){
            DataEntity entity =form.toDataEntity();
            getService().update(entity);
            form.fromDataEntity(entity);
            form.setSrfuf("1");
            return ResponseEntity.ok().body(form);
	}
	@GetMapping(value="maineditform/remove")
	public ResponseEntity<DataEntity_EditForm_Main> mainEditFormRemove(@Validated @NotBlank(message = "srfkey不允许为空") @RequestParam("srfkey")String srfkey){
            DataEntity_EditForm_Main form=new DataEntity_EditForm_Main();
            DataEntity entity = new DataEntity();
            entity.setDeid(srfkey);
            getService().remove(entity);
            form.setSrfuf("0");
            form.fromDataEntity(entity);
            return ResponseEntity.ok().body(form);
	}
	@PostMapping(value="maineditform/getdraft")
	public ResponseEntity<DataEntity_EditForm_Main> mainEditFormGetDraft(@RequestBody DataEntity_EditForm_Main form){
        if(!StringUtils.isEmpty(form.getSrfsourcekey()))
        {
            DataEntity sourceEntity =new DataEntity();
            sourceEntity.setDeid(form.getSrfsourcekey());
            this.getService().get(sourceEntity);

			DataEntity targetEntity =new DataEntity();
			sourceEntity.copyTo(targetEntity);
			form.fromDataEntity(targetEntity,false);
            form.setSrfuf("0");
            return ResponseEntity.ok().body(form);
         }
            DataEntity entity =form.toDataEntity();
            getService().getDraft(entity);
            form.fromDataEntity(entity);
            form.setSrfuf("0");
            return ResponseEntity.ok().body(form);
	}
	@GetMapping(value="maineditform/get")
	public ResponseEntity<DataEntity_EditForm_Main> mainEditFormGet(@Validated @NotBlank(message = "srfkey不允许为空") @RequestParam("srfkey")String srfkey){
            DataEntity_EditForm_Main form=new DataEntity_EditForm_Main();
            DataEntity entity = new DataEntity();
            entity.setDeid(srfkey);
            entity=getService().get(entity);
            form.setSrfuf("1");
            form.fromDataEntity(entity);
            return ResponseEntity.ok().body(form);
	}
	@PostMapping(value="maineditform/create")
	public ResponseEntity<DataEntity_EditForm_Main> mainEditFormCreate(@Validated @RequestBody DataEntity_EditForm_Main form){
            DataEntity entity =form.toDataEntity();
            getService().create(entity);
            form.fromDataEntity(entity);
            form.setSrfuf("1");
            return ResponseEntity.ok().body(form);
	}
	@PostMapping(value="maingrid/update")
	public DataEntity mainGridUpdate(@Validated DataEntity mainItem){
		return mainItem;
	}
	@PostMapping(value="maingrid/remove")
	public ResponseEntity<DataEntity> mainGridRemove(@Validated @RequestBody Map args){
	    DataEntity entity =new DataEntity();
	    if ( !StringUtils.isEmpty(args.get("srfkeys"))) {
			String srfkeys=args.get("srfkeys").toString();
			String srfkeyArr[] =srfkeys.split(";");
			for(String srfkey : srfkeyArr)
			{
				if(!StringUtils.isEmpty(srfkey)){
				entity.setDeid(srfkey);
				this.getService().remove(entity);
                }
            }
        }
		return ResponseEntity.ok().body(entity);
	}
	public DataEntity mainGridGet(String deid){
		return null;
	}
	@PostMapping(value="maingrid/getdraft")
	public DataEntity mainGridGetDraft(@Validated DataEntity mainItem){
		return mainItem;
	}
	@PostMapping(value="maingrid/create")
	public DataEntity mainGridCreate(@Validated DataEntity mainItem){
		return mainItem;
	}
	@org.springframework.beans.factory.annotation.Value("${ibiz.filePath}")
    private String strFilePath;
	@Autowired
    private com.sa.ibiz.demo.ibizutil.service.IBZFILEService ibzfileService;
	/**
	 * [main]表格数据导出
	 * @param searchFilter
	 * @return
	 * @throws
	 * @throws
	 */
	@PostMapping(value="maingrid/exportdata/searchdefault")
	public ResponseEntity<Page<JSONObject>> maingridExportDataSearchDefault(@Validated @RequestBody DataEntitySearchFilter searchFilter) throws IOException, jxl.write.WriteException {
		String fileid=com.baomidou.mybatisplus.core.toolkit.IdWorker.get32UUID();
		String localPath=ExportDataInit(fileid);//输出文件相对路径
		Page<DataEntity> searchResult = this.getService().searchDefault(searchFilter);//1.查询表格数据
		List<Map<String,Object>> datas=DataEntity_Grid_Main.pageToListDatas(searchResult);//2.将数据转换成list
		List<Map<String,String>> colnums=DataEntity_Grid_Main.getGridColumnModels();//3.获取表格列头
        java.io.File outputFile=com.sa.ibiz.demo.ibizutil.helper.DEDataExportHelper.output(strFilePath+localPath,colnums,datas);//4.生成导出文件
		com.sa.ibiz.demo.ibizutil.helper.DEDataExportHelper.saveFileData(outputFile,localPath,fileid,ibzfileService); //5.保存file表记录
		String strDownloadUrl =String.format("ibizutil/download/"+fileid);//6.回传文件路径给前台
        Page<JSONObject> resultObj=DataEntity_Grid_Main.getResultPage(searchResult,strDownloadUrl);//7.获取输出对象
			return ResponseEntity.ok().body(resultObj);
	}
	/**
	 * 表格数据导出
	 * @param fileid
	 * @return
	 */
	private String ExportDataInit(String fileid) {
		java.text.SimpleDateFormat dateFormat = new java.text.SimpleDateFormat("yyyyMMdd");
        String filepath=dateFormat.format(new java.util.Date())+ java.io.File.separator;
        java.text.SimpleDateFormat dateFormat2 = new java.text.SimpleDateFormat("yyyyMMddHHmmss");
		String strTempFileName = fileid+"-"+dateFormat2.format(new java.util.Date())+".xls";
		java.io.File file =new java.io.File(strFilePath+filepath);
		if(!file.exists())
           file.mkdirs();
		return filepath+strTempFileName;
	}
	@PostMapping(value="maingrid/searchdefault")
	public ResponseEntity<Page<DataEntity_Grid_Main>> mainGridSearchDefault(@Validated @RequestBody DataEntitySearchFilter searchFilter){
			Page<DataEntity> searchResult = this.getService().searchDefault(searchFilter);
			Page<DataEntity_Grid_Main> searchResult_vo_data =DataEntity_Grid_Main.fromDataEntity(searchResult);
					return ResponseEntity.ok().body(searchResult_vo_data);
	}
	@PostMapping(value="defaultsearchform/load")
	public void defaultSearchFormLoad(){

	}
   	@PostMapping(value="defaultsearchform/loaddraft")
	public ResponseEntity<DataEntity_SearchForm_Default> defaultSearchFormLoadDraft(@Validated @RequestBody DataEntity_SearchForm_Default searchform){
 		 
			DataEntitySearchFilter searchfilter =searchform.toDataEntitySearchFilter();
			searchform.fromDataEntitySearchFilter(searchfilter);
			return ResponseEntity.ok().body(searchform);
	} 
	@PostMapping(value="defaultsearchform/search")
	public void defaultSearchFormSearch(){
			 
	} 
 }